<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>Mailbox Driver External Functions</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<table width=100%>
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border=0 src="../../tilogo.gif"></a></td>
  <td bgcolor="red"><img src="../../titagline.gif"></td>
</tr>
</table>
<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Mailbox Driver External Functions<div class="ingroups"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r.html">MAILBOX Driver</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>This section has a list of all the exported API which the application needs to invoke in order to use the driver.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:gae97af689efdd7154ac9ec77b4fad1d45"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gae97af689efdd7154ac9ec77b4fad1d45">Mailbox_close</a> (<a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gac7f59f1473cd97e25d4f6b01b8af8c5d">Mbox_Handle</a> handle)</td></tr>
<tr class="memdesc:gae97af689efdd7154ac9ec77b4fad1d45"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function to close a Mailbox peripheral specified by the Mailbox handle.  <a href="#gae97af689efdd7154ac9ec77b4fad1d45">More...</a><br /></td></tr>
<tr class="separator:gae97af689efdd7154ac9ec77b4fad1d45"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad110d05631bfcefdddebb6989812efb5"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gad110d05631bfcefdddebb6989812efb5">Mailbox_init</a> (<a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga3fd8433860dbf1ce1d5692461a8603ee">Mailbox_Type</a> localEndpoint)</td></tr>
<tr class="memdesc:gad110d05631bfcefdddebb6989812efb5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function to initialize the Mailbox module.<br />
 It must be called only once per local endpoint.  <a href="#gad110d05631bfcefdddebb6989812efb5">More...</a><br /></td></tr>
<tr class="separator:gad110d05631bfcefdddebb6989812efb5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadf714280d09ff28cc6f95c1ceb9fa790"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gac7f59f1473cd97e25d4f6b01b8af8c5d">Mbox_Handle</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gadf714280d09ff28cc6f95c1ceb9fa790">Mailbox_open</a> (<a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga3fd8433860dbf1ce1d5692461a8603ee">Mailbox_Type</a> remoteEndpoint, const <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga566c808f4a14ffe067a3ac60a513928e">Mailbox_Config</a> *cfg, int32_t *errCode)</td></tr>
<tr class="memdesc:gadf714280d09ff28cc6f95c1ceb9fa790"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function to initialize an instance of the mailbox driver.  <a href="#gadf714280d09ff28cc6f95c1ceb9fa790">More...</a><br /></td></tr>
<tr class="separator:gadf714280d09ff28cc6f95c1ceb9fa790"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gafb11aa98776b93b1bff62d60a9143bd4"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gafb11aa98776b93b1bff62d60a9143bd4">Mailbox_Config_init</a> (<a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga566c808f4a14ffe067a3ac60a513928e">Mailbox_Config</a> *cfg)</td></tr>
<tr class="memdesc:gafb11aa98776b93b1bff62d60a9143bd4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function to initialize the Mailbox_Config struct to its defaults.  <a href="#gafb11aa98776b93b1bff62d60a9143bd4">More...</a><br /></td></tr>
<tr class="separator:gafb11aa98776b93b1bff62d60a9143bd4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7e5cccca0cf69a3d7db72cb116318713"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga7e5cccca0cf69a3d7db72cb116318713">Mailbox_write</a> (<a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gac7f59f1473cd97e25d4f6b01b8af8c5d">Mbox_Handle</a> handle, const uint8_t *buffer, uint32_t size)</td></tr>
<tr class="memdesc:ga7e5cccca0cf69a3d7db72cb116318713"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that writes data to a Mailbox.  <a href="#ga7e5cccca0cf69a3d7db72cb116318713">More...</a><br /></td></tr>
<tr class="separator:ga7e5cccca0cf69a3d7db72cb116318713"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga1d1d54e6e305cd1523694e748edaded7"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga1d1d54e6e305cd1523694e748edaded7">Mailbox_read</a> (<a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gac7f59f1473cd97e25d4f6b01b8af8c5d">Mbox_Handle</a> handle, uint8_t *buffer, uint32_t size)</td></tr>
<tr class="memdesc:ga1d1d54e6e305cd1523694e748edaded7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that reads data from a Mailbox.  <a href="#ga1d1d54e6e305cd1523694e748edaded7">More...</a><br /></td></tr>
<tr class="separator:ga1d1d54e6e305cd1523694e748edaded7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0d25769fbce366f54005349726db58ea"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga0d25769fbce366f54005349726db58ea">Mailbox_readFlush</a> (<a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gac7f59f1473cd97e25d4f6b01b8af8c5d">Mbox_Handle</a> handle)</td></tr>
<tr class="memdesc:ga0d25769fbce366f54005349726db58ea"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that should be called after application is done reading the message.  <a href="#ga0d25769fbce366f54005349726db58ea">More...</a><br /></td></tr>
<tr class="separator:ga0d25769fbce366f54005349726db58ea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9ec1b6825c7d7c6a4b6c91adba8b2321"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga9ec1b6825c7d7c6a4b6c91adba8b2321">Mailbox_writeReset</a> (<a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gac7f59f1473cd97e25d4f6b01b8af8c5d">Mbox_Handle</a> handle)</td></tr>
<tr class="memdesc:ga9ec1b6825c7d7c6a4b6c91adba8b2321"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that should be called if application is unable to write to mailbox.  <a href="#ga9ec1b6825c7d7c6a4b6c91adba8b2321">More...</a><br /></td></tr>
<tr class="separator:ga9ec1b6825c7d7c6a4b6c91adba8b2321"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga483fc243aa815cf3fb997e9dec4ba3d8"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga483fc243aa815cf3fb997e9dec4ba3d8">Mailbox_getStats</a> (<a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gac7f59f1473cd97e25d4f6b01b8af8c5d">Mbox_Handle</a> handle, <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga2e985a30d94e9fb71612c06d8a9db96a">Mailbox_Stats</a> *stats)</td></tr>
<tr class="memdesc:ga483fc243aa815cf3fb997e9dec4ba3d8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that collects mailbox driver statistics.  <a href="#ga483fc243aa815cf3fb997e9dec4ba3d8">More...</a><br /></td></tr>
<tr class="separator:ga483fc243aa815cf3fb997e9dec4ba3d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>This section has a list of all the exported API which the application needs to invoke in order to use the driver. </p>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="gae97af689efdd7154ac9ec77b4fad1d45"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t Mailbox_close </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gac7f59f1473cd97e25d4f6b01b8af8c5d">Mbox_Handle</a>&#160;</td>
          <td class="paramname"><em>handle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function to close a Mailbox peripheral specified by the Mailbox handle. </p>
<dl class="section pre"><dt>Precondition</dt><dd><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gadf714280d09ff28cc6f95c1ceb9fa790" title="Function to initialize an instance of the mailbox driver. ">Mailbox_open()</a> has been called.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>A Mbox_Handle returned from <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gadf714280d09ff28cc6f95c1ceb9fa790" title="Function to initialize an instance of the mailbox driver. ">Mailbox_open()</a></td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gadf714280d09ff28cc6f95c1ceb9fa790" title="Function to initialize an instance of the mailbox driver. ">Mailbox_open()</a></dd></dl>
<dl class="section return"><dt>Returns</dt><dd>Returns error code in case of failure. </dd></dl>

</div>
</div>
<a class="anchor" id="gafb11aa98776b93b1bff62d60a9143bd4"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t Mailbox_Config_init </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga566c808f4a14ffe067a3ac60a513928e">Mailbox_Config</a> *&#160;</td>
          <td class="paramname"><em>cfg</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function to initialize the Mailbox_Config struct to its defaults. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">cfg</td><td>A pointer to Mailbox_Config structure for initialization</td></tr>
  </table>
  </dd>
</dl>
<p>Defaults values are: </p><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;readMode         = Mailbox_MODE_BLOCKING</div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;writeMode        = Mailbox_MODE_BLOCKING</div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;readTimeout      = MAILBOX_WAIT_FOREVER     </div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;writeTimeout     = MAILBOX_WAIT_FOREVER    </div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;readCallback     = NULL</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;opMode           = MAILBOX_OPERATION_MODE_PARTIAL_READ_ALLOWED</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;dataTransferMode = MAILBOX_DATA_TRANSFER_MEMCPY</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;chType           = MAILBOX_CHTYPE_SINGLE</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;chId             = MAILBOX_CH_ID_0   </div></div><!-- fragment --><dl class="section warning"><dt>Warning</dt><dd>On <b>XWR14xx</b> the fields chType and chId are NOT used. Application does not need to set these fields in <b>XWR14xx</b>.<br />
 On <b>XWR16xx</b> the fields chType and chId are used for the communication between MSS&lt;-&gt;DSS only and need to be set accordingly.<br />
 For MSS&lt;-&gt;BSS or DSS&lt;-&gt;BSS communication in <b>XWR16xx</b> application does not need to set these fields.</dd></dl>
<dl class="section return"><dt>Returns</dt><dd>Returns error code in case of failure. </dd></dl>

</div>
</div>
<a class="anchor" id="ga483fc243aa815cf3fb997e9dec4ba3d8"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t Mailbox_getStats </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gac7f59f1473cd97e25d4f6b01b8af8c5d">Mbox_Handle</a>&#160;</td>
          <td class="paramname"><em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga2e985a30d94e9fb71612c06d8a9db96a">Mailbox_Stats</a> *&#160;</td>
          <td class="paramname"><em>stats</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function that collects mailbox driver statistics. </p>
<p>This function is used to collect mailbox driver statistics. It's main purpose is debugging of mailbox driver.</p>
<dl class="section pre"><dt>Precondition</dt><dd><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gadf714280d09ff28cc6f95c1ceb9fa790" title="Function to initialize an instance of the mailbox driver. ">Mailbox_open()</a> has been called</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>A Mbox_Handle </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">stats</td><td>Pointer to mailbox stats structure to be filled</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Returns error code in case of failure. </dd></dl>

</div>
</div>
<a class="anchor" id="gad110d05631bfcefdddebb6989812efb5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t Mailbox_init </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga3fd8433860dbf1ce1d5692461a8603ee">Mailbox_Type</a>&#160;</td>
          <td class="paramname"><em>localEndpoint</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function to initialize the Mailbox module.<br />
 It must be called only once per local endpoint. </p>
<dl class="section pre"><dt>Precondition</dt><dd>This function must be called before any other Mailbox driver API is used.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">localEndpoint</td><td>Type of local mailbox endpoint.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Returns error code in case of failure. </dd></dl>

</div>
</div>
<a class="anchor" id="gadf714280d09ff28cc6f95c1ceb9fa790"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gac7f59f1473cd97e25d4f6b01b8af8c5d">Mbox_Handle</a> Mailbox_open </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga3fd8433860dbf1ce1d5692461a8603ee">Mailbox_Type</a>&#160;</td>
          <td class="paramname"><em>remoteEndpoint</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga566c808f4a14ffe067a3ac60a513928e">Mailbox_Config</a> *&#160;</td>
          <td class="paramname"><em>cfg</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t *&#160;</td>
          <td class="paramname"><em>errCode</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function to initialize an instance of the mailbox driver. </p>
<p>For <b>XWR14xx</b>: <br />
Between MSS&lt;-&gt;BSS only one instance of the driver can be opened.<br />
For <b>XWR16xx</b>: <br />
Between MSS&lt;-&gt;BSS only one instance of the driver can be opened.<br />
Between DSS&lt;-&gt;BSS only one instance of the driver can be opened.<br />
Between MSS&lt;-&gt;DSS multiple instances of the driver can be opened (each instance controls one virtual mailbox channel).<br />
</p><dl class="section see"><dt>See also</dt><dd><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gacc846aad9f1e171d503751b7c1de3451" title="Mailbox channel type. ">Mailbox_ChType</a> <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga39afb53a3aef9f10301e6ad9b7ed5e39" title="Mailbox channel ID. ">Mailbox_ChID</a></dd></dl>
<dl class="section pre"><dt>Precondition</dt><dd><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gad110d05631bfcefdddebb6989812efb5" title="Function to initialize the Mailbox module.  It must be called only once per local endpoint...">Mailbox_init()</a> has been called</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">cfg</td><td>Pointer to configuration block. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">remoteEndpoint</td><td>Remote endpoint that this mailbox instance will communicate with. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">errCode</td><td>Pointer to error code value/status to be returned by the function</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A Mbox_Handle upon success. NULL if an error occurs.</dd></dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gad110d05631bfcefdddebb6989812efb5" title="Function to initialize the Mailbox module.  It must be called only once per local endpoint...">Mailbox_init()</a> </dd>
<dd>
<a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gae97af689efdd7154ac9ec77b4fad1d45" title="Function to close a Mailbox peripheral specified by the Mailbox handle. ">Mailbox_close()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga1d1d54e6e305cd1523694e748edaded7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t Mailbox_read </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gac7f59f1473cd97e25d4f6b01b8af8c5d">Mbox_Handle</a>&#160;</td>
          <td class="paramname"><em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>buffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>size</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function that reads data from a Mailbox. </p>
<p>Mailbox can only read one message at a time from a remote endpoint. Multiple <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga1d1d54e6e305cd1523694e748edaded7" title="Function that reads data from a Mailbox. ">Mailbox_read()</a> calls can be done for the same message in the mailbox.</p>
<p>E.g. Application can read part of the message to figure out full message length and issue a subsequent <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga1d1d54e6e305cd1523694e748edaded7" title="Function that reads data from a Mailbox. ">Mailbox_read()</a>.</p>
<p>Mailbox driver keeps track internally of number of bytes read for a message. The first <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga1d1d54e6e305cd1523694e748edaded7" title="Function that reads data from a Mailbox. ">Mailbox_read()</a> for a message always starts at byte zero. In case of multiple <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga1d1d54e6e305cd1523694e748edaded7" title="Function that reads data from a Mailbox. ">Mailbox_read()</a> calls for the same message, the subsequent reads start in the next byte from where the previous read stopped. Once application finishes reading the message it <b>must</b> issue a <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga0d25769fbce366f54005349726db58ea" title="Function that should be called after application is done reading the message. ">Mailbox_readFlush()</a> to release the mailbox buffer and notify the remote endpoint.<br />
 The maximum size of the mailbox buffer is given by <a class="el" href="mailbox_8h.html#a60dd01433666c9888c1967b96286cd9e" title="Mailbox buffer size (in bytes) for data transfer (per direction). ">MAILBOX_DATA_BUFFER_SIZE</a>. Application code is responsible for fragmentation of the message if the size is bigger than the mailbox buffer.</p>
<p>All interrupts related to the read operation are managed by the driver and are not exposed to the application. Returns number of bytes read or error.</p>
<p>Read modes:</p>
<p>In Mailbox_MODE_BLOCKING: <br />
If this is the first read on a new message, <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga1d1d54e6e305cd1523694e748edaded7" title="Function that reads data from a Mailbox. ">Mailbox_read()</a> will block task execution until a new message has arrived in the local Mailbox buffer and it is copied to the application buffer. If this is not a new message, <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga1d1d54e6e305cd1523694e748edaded7" title="Function that reads data from a Mailbox. ">Mailbox_read()</a> will block task execution until "size" bytes are copied to the application buffer.</p>
<p>In Mailbox_MODE_POLLING: <br />
If this is the first read on a new message and the new message has not arrived, <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga1d1d54e6e305cd1523694e748edaded7" title="Function that reads data from a Mailbox. ">Mailbox_read()</a> will return size zero to indicate no bytes were read. If the new message has arrived or if this is not a new message, <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga1d1d54e6e305cd1523694e748edaded7" title="Function that reads data from a Mailbox. ">Mailbox_read()</a> will copy the data to application buffer. <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga1d1d54e6e305cd1523694e748edaded7" title="Function that reads data from a Mailbox. ">Mailbox_read()</a> will return after "size" bytes are copied to the application buffer.</p>
<p>In Mailbox_MODE_CALLBACK: <br />
The driver will invoke the application callback function once a new message is received in the mailbox. Application is responsible for calling <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga1d1d54e6e305cd1523694e748edaded7" title="Function that reads data from a Mailbox. ">Mailbox_read()</a> to read the new message. <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga1d1d54e6e305cd1523694e748edaded7" title="Function that reads data from a Mailbox. ">Mailbox_read()</a> copies the data into the application buffer and then exit.</p>
<p>In any of the modes described above, <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga0d25769fbce366f54005349726db58ea" title="Function that should be called after application is done reading the message. ">Mailbox_readFlush()</a> needs to be issued after the message is fully read by the application.</p>
<dl class="section pre"><dt>Precondition</dt><dd><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gadf714280d09ff28cc6f95c1ceb9fa790" title="Function to initialize an instance of the mailbox driver. ">Mailbox_open()</a> has been called</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>A Mbox_Handle</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">buffer</td><td>A pointer to an empty buffer in which received data should be written to.</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">size</td><td>The number of bytes to be written into buffer</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Returns the number of bytes that have been read from the Mailbox. If an error occurs, one of the Mailbox Error codes is returned.</dd></dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga0d25769fbce366f54005349726db58ea" title="Function that should be called after application is done reading the message. ">Mailbox_readFlush()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga0d25769fbce366f54005349726db58ea"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t Mailbox_readFlush </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gac7f59f1473cd97e25d4f6b01b8af8c5d">Mbox_Handle</a>&#160;</td>
          <td class="paramname"><em>handle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function that should be called after application is done reading the message. </p>
<p>Notifies the remote endpoint that the local mailbox is ready to receive a new message after the previous message was read.<br />
Remote endpoint can not send a new message to the local endpoint until <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga0d25769fbce366f54005349726db58ea" title="Function that should be called after application is done reading the message. ">Mailbox_readFlush()</a> is issued by the local endpoint. Once <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga0d25769fbce366f54005349726db58ea" title="Function that should be called after application is done reading the message. ">Mailbox_readFlush()</a> is issued, the local endpoint must assume that the previously received message is no longer in the mailbox buffer and subsequent <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga1d1d54e6e305cd1523694e748edaded7" title="Function that reads data from a Mailbox. ">Mailbox_read()</a> will return no data until a new message arrives in the mailbox.</p>
<dl class="section pre"><dt>Precondition</dt><dd><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gadf714280d09ff28cc6f95c1ceb9fa790" title="Function to initialize an instance of the mailbox driver. ">Mailbox_open()</a> has been called</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>A Mbox_Handle</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Returns error code in case of failure.</dd></dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga1d1d54e6e305cd1523694e748edaded7" title="Function that reads data from a Mailbox. ">Mailbox_read()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga7e5cccca0cf69a3d7db72cb116318713"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t Mailbox_write </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gac7f59f1473cd97e25d4f6b01b8af8c5d">Mbox_Handle</a>&#160;</td>
          <td class="paramname"><em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>buffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>size</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function that writes data to a Mailbox. </p>
<p>Mailbox can only send one message at a time to a remote endpoint. After data is copied to mailbox buffer, driver triggers interrupt to remote endpoint. This means that a call to the <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga7e5cccca0cf69a3d7db72cb116318713" title="Function that writes data to a Mailbox. ">Mailbox_write()</a> is always a complete mailbox transaction. A new message can only be sent after the previous message has been acknowledged by the remote endpoint. The acknowledgement process is handled internally by the driver. All interrupts related to the write operations are managed by the driver and are not exposed to the application. If called with data that will surpass the maximum size of the mailbox buffer, the write operation will fail with an error code and nothing will be written to the mailbox buffer. Returns number of bytes written or error.<br />
The maximum size of the mailbox buffer is given by <a class="el" href="mailbox_8h.html#a60dd01433666c9888c1967b96286cd9e" title="Mailbox buffer size (in bytes) for data transfer (per direction). ">MAILBOX_DATA_BUFFER_SIZE</a>. Application code is responsible for fragmentation of the message if the size is bigger than the mailbox buffer.</p>
<p>Write modes:</p>
<p>In Mailbox_MODE_BLOCKING: <br />
 <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga7e5cccca0cf69a3d7db72cb116318713" title="Function that writes data to a Mailbox. ">Mailbox_write()</a> will block task execution until the message has been copied from application to the mailbox buffer and an acknowledgement is received from the remote endpoint. If a new <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga7e5cccca0cf69a3d7db72cb116318713" title="Function that writes data to a Mailbox. ">Mailbox_write()</a> is issued before the acknowledgement is received, the write will fail with an error code returned to application.</p>
<p>In Mailbox_MODE_POLLING: <br />
 <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga7e5cccca0cf69a3d7db72cb116318713" title="Function that writes data to a Mailbox. ">Mailbox_write()</a> will block task execution until the message has been copied from application to the mailbox buffer but it does not wait for an acknowledgement from the remote endpoint. If a new <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga7e5cccca0cf69a3d7db72cb116318713" title="Function that writes data to a Mailbox. ">Mailbox_write()</a> is issued before the acknowledgement is received, the write will fail with an error code returned to application. In this mode, application does not know when acknowledgement is received and it may try to write the next message multiple times until it succeeds as if it is polling for the status of the acknowledgement.</p>
<dl class="section pre"><dt>Precondition</dt><dd><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gadf714280d09ff28cc6f95c1ceb9fa790" title="Function to initialize an instance of the mailbox driver. ">Mailbox_open()</a> has been called</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>A Mbox_Handle</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">buffer</td><td>A pointer to buffer containing data to be written to the Mailbox.</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">size</td><td>The number of bytes in the buffer that should be written to the Mailbox.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Returns the number of bytes that have been written to the Mailbox. If an error occurs, one of the Mailbox Error codes is returned.</dd></dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga9ec1b6825c7d7c6a4b6c91adba8b2321" title="Function that should be called if application is unable to write to mailbox. ">Mailbox_writeReset()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga9ec1b6825c7d7c6a4b6c91adba8b2321"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t Mailbox_writeReset </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gac7f59f1473cd97e25d4f6b01b8af8c5d">Mbox_Handle</a>&#160;</td>
          <td class="paramname"><em>handle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function that should be called if application is unable to write to mailbox. </p>
<p>This function is used to handle the abnormal situation when an acknowledgement was never received for the previous message sent in the mailbox. This acknowledgement is at the internal Mailbox Peripheral protocol layer and the application perceives this situation when a call to <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga7e5cccca0cf69a3d7db72cb116318713" title="Function that writes data to a Mailbox. ">Mailbox_write()</a> returns error code <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_r_r_o_r___c_o_d_e.html#ga5c5e9e23cd9f939e9af684a338c75197" title="Error Code: TX mailbox full. Application tried to send a message before ACK of the previously TX mess...">MAILBOX_ETXFULL</a>.</p>
<p>This condition can arise in two circumstances:</p><ol type="1">
<li>Not enough processing time: The local endpoint is sending a message before the remote endpoint had chance to acknowledge the previous message (not enough time).</li>
<li>Enough processing time: The remote endpoint did not acknowledge the previous message even though enough time has elapsed. This indicates an error condition in the remote endpoint.</li>
</ol>
<p><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga9ec1b6825c7d7c6a4b6c91adba8b2321" title="Function that should be called if application is unable to write to mailbox. ">Mailbox_writeReset()</a> resets the mailbox driver state machine so that application can send a new message to the remote endpoint.</p>
<p>After invoking this function, the application can proceed to write a new message to the remote endpoint using <a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga7e5cccca0cf69a3d7db72cb116318713" title="Function that writes data to a Mailbox. ">Mailbox_write()</a>.</p>
<dl class="section pre"><dt>Precondition</dt><dd><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gadf714280d09ff28cc6f95c1ceb9fa790" title="Function to initialize an instance of the mailbox driver. ">Mailbox_open()</a> has been called</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>A Mbox_Handle</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Returns error code in case of failure.</dd></dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group___m_a_i_l_b_o_x___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga7e5cccca0cf69a3d7db72cb116318713" title="Function that writes data to a Mailbox. ">Mailbox_write()</a> </dd></dl>

</div>
</div>
</div><!-- contents -->
<hr size="1"><small>
Copyright  2018, Texas Instruments Incorporated</small>
</body>
</html>
